hdu 1969

Pie

Time Limit: 5000/1000 MS (Java/Others) Memory Limit: 65536/32768 K (Java/Others)

Total Submission(s): 109 Accepted Submission(s): 52


Problem Description

My birthday is coming up and traditionally I'm serving pie. Not just one pie, no, I have a number N of them, of various tastes and of various sizes. F of my friends are coming to my party and each of them gets a piece of pie. This should be one piece of one pie, not several small pieces since that looks messy. This piece can be one whole pie though.

My friends are very annoying and if one of them gets a bigger piece than the others, they start complaining. Therefore all of them should get equally sized (but not necessarily equally shaped) pieces, even if this leads to some pie getting spoiled (which is better than spoiling the party). Of course, I want a piece of pie for myself too, and that piece should also be of the same size.

What is the largest possible piece size all of us can get? All the pies are cylindrical in shape and they all have the same height 1, but the radii of the pies can be different.

 

Input

One line with a positive integer: the number of test cases. Then for each test case:
---One line with two integers N and F with 1 <= N, F <= 10 000: the number of pies and the number of friends.
---One line with N integers ri with 1 <= ri <= 10 000: the radii of the pies.

 

Output

For each test case, output one line with the largest possible volume V such that me and my friends can all get a pie piece of size V. The answer should be given as a floating point number with an absolute error of at most 10^(-3).

 


Sample Input
3
3 3
4 3 3
1 24
5
10 5
1 4 2 3 4 5 6 5 4 2

Sample Output
25.1327
3.1416
50.2655
題意:
一個人要辦生日part,有f個餡餅,n個朋友要來參加他的生日part,我們要做的是讓着f個餡餅平均分給他的朋友,
形狀可以不一樣,但是大小要一樣,也就是說餡餅的體積要一樣,這餡餅的高都爲1。這個簡單,但是題目要求不能分
從一塊一塊的湊出來的餡餅。

思路:

用二分搜索,首先算出餡餅的總體積,然後再除以總人數,要注意總人數要加1,因爲生日的主人也包括在內,總體積就是

大家能夠的到的最大餡餅的體積,但是不能從一塊到另一塊湊出來,所以要進行二分搜索,mid=(l+r)/2,當達到題意是就退出

循環,輸出mid.這裏PI的精度要高一些,用acos(-1.0)。

代碼:

#include<cstdio>
#include<cmath>
#define PI acos(-1);
double v[10001];
int main()
{
    int T,n,f,ri;
    double l,r,mid,sum;
    scanf("%d",&T);
    while(T--)
    {

        r=l=0;
        scanf("%d%d",&n,&f);
        f++;
        for(int i=0;i<n;i++)
            {
                scanf("%d",&ri);
                v[i]=ri*ri*PI;
                r+=v[i];

            }
            r/=f;
            while(r-l>=1e-6)
            {

                sum=0;
                mid=(l+r)/2.0;
                for(int i=0;i<n;i++)
                    sum+=(int)(v[i]/mid);
                if(sum>=f)
                    l=mid;
                else r=mid;
            }
            printf("%.4lf\n",mid);

    }
    return 0;
}





發佈了76 篇原創文章 · 獲贊 7 · 訪問量 4萬+
發表評論
所有評論
還沒有人評論,想成為第一個評論的人麼? 請在上方評論欄輸入並且點擊發布.
相關文章